ip = "192.168.1.1"
octets = ip.split(".")

# Convert to integers
oct1 = int(octets[0])
oct2 = int(octets[1])
oct3 = int(octets[2])
oct4 = int(octets[3])

# Convert to binary strings (removing the '0b' prefix)
bin1 = bin(oct1)[2:].zfill(8)
bin2 = bin(oct2)[2:].zfill(8)
bin3 = bin(oct3)[2:].zfill(8)
bin4 = bin(oct4)[2:].zfill(8)

# Check private IP ranges
is_class_a = oct1 == 10
is_class_b = oct1 == 172 and (oct2 >= 16 and oct2 <= 31)
is_class_c = oct1 == 192 and oct2 == 168

# Combined check
is_private = is_class_a or is_class_b or is_class_c

print(f"IP: {ip}")
print(f"Octet 1: {oct1} ({bin1})")
print(f"Octet 2: {oct2} ({bin2})")
print(f"Octet 3: {oct3} ({bin3})")
print(f"Octet 4: {oct4} ({bin4})")
print("Private IP Range Checks:")
print(f"Class A (10.0.0.0/8): {is_class_a}")
print(f"Class B (172.16.0.0/12): {is_class_b}")
print(f"Class C (192.168.0.0/16): {is_class_c}")
print(f"Is Private IP: {is_private}")