# Exercise 2: List Slicing and Dictionary Modification - Solution

# Part 1: List Slicing

numbers = [0, 1, 2, 3, 4, 5, 6, 7, 8, 9]

# 1. First half.
first_half = numbers[:len(numbers) // 2]
print(first_half)  # Output: [0, 1, 2, 3, 4]

# 2. Last three elements.
last_three = numbers[-3:]
print(last_three)  # Output: [7, 8, 9]

# 3. Every other element.
every_other = numbers[::2]
print(every_other)  # Output: [0, 2, 4, 6, 8]

# 4. Reversed list using slicing.
reversed_numbers = numbers[::-1]
print(reversed_numbers)  # Output: [9, 8, 7, 6, 5, 4, 3, 2, 1, 0]

# 5. In-place modification.
numbers[2:5] = [100, 200, 300]
print(numbers)  # Output: [0, 1, 100, 200, 300, 5, 6, 7, 8, 9]


# Part 2: Dictionary Modification

inventory = {
    "apple": 10,
    "banana": 5,
    "orange": 12,
    "grape": 8
}

# 1. Increase "apple" quantity.
inventory["apple"] += 5

# 2. Decrease "orange" quantity.
inventory["orange"] -= 3

# 3. Remove "banana".
del inventory["banana"]  # or inventory.pop("banana")

# 4. Add "pear".
inventory["pear"] = 7

# 5. Print the inventory.
print(inventory)  # Output (order might vary): {'apple': 15, 'orange': 9, 'grape': 8, 'pear': 7}

# 6. Use .update()
inventory.update({"kiwi": 4, "orange": 15})
print(inventory) # Expected Output: {'apple': 15, 'orange': 15, 'grape': 8, 'pear': 7, 'kiwi': 4}