# Exercise 4: Log File Analysis (Basic) - Solution

log_entries = [
    "INFO: User logged in: user123",
    "ERROR: Connection failed: 192.168.1.100",
    "WARNING: Disk space low",
    "INFO: User logged out: user123",
    "ERROR: Authentication failure: user456",
    "INFO: Service started: webserver",
    "ERROR: Connection failed: 192.168.1.101",
]

# 1. Error entries.
error_entries = []
for entry in log_entries:
    if entry.startswith("ERROR"):
        error_entries.append(entry)

# 2. User logins.
user_logins = {}
for entry in log_entries:
    if entry.startswith("INFO: User logged in:"):
        parts = entry.split(":")
        username = parts[-1].strip()  # Extract username and remove whitespace
        user_logins[username] = user_logins.get(username, 0) + 1

# 3. Failed IPs.
failed_ips = []
for entry in log_entries:
    if entry.startswith("ERROR: Connection failed:"):
        parts = entry.split(":")
        ip_address = parts[-1].strip()  # Extract IP and remove whitespace
        failed_ips.append(ip_address)

# 4. Print results.
print("Error Entries:", error_entries)
print("User Logins:", user_logins)
print("Failed IPs:", failed_ips)

# 5. Unique failed IPs
unique_ips = []
for ip in failed_ips:
    if ip not in unique_ips:
        unique_ips.append(ip)

print(f"Number of unique IPs in failed_ips: {len(unique_ips)}")