# Exercise 5: Firewall Rule Configuration

# You are managing a firewall and have a list of rules represented as dictionaries.

firewall_rules = [
    {"source": "192.168.1.0/24", "destination": "10.0.0.1", "port": 80, "action": "allow"},
    {"source": "10.0.0.0/16", "destination": "192.168.1.100", "port": 22, "action": "deny"},
    {"source": "ANY", "destination": "10.0.0.2", "port": 443, "action": "allow"},
    {"source": "192.168.1.50", "destination": "10.0.0.3", "port": 80, "action": "allow"},
]

# 1. Create a new list called `allowed_rules` containing only the rules where the action is "allow".
# 2. Create a dictionary called `ports_by_destination` where keys are destination IP addresses and values are *lists* of ports that are either allowed or denied for that destination.
# 3. Given a source IP, destination IP, and port, create a function `check_rule(source, destination, port, rules)` that returns "allow" if the traffic is allowed, "deny" if denied, and "unknown" if no matching rule is found.  Test it with the following:
#    - source = "192.168.1.50", destination = "10.0.0.1", port = 80  (should be "allow")
#    - source = "10.0.0.5", destination = "192.168.1.100", port = 22 (should be "deny")
#    - source = "10.0.0.5", destination = "192.168.1.100", port = 80 (should be "unknown")
# 4.  Add a new rule to `firewall_rules` that denies all traffic from "172.16.0.0/12" to any destination on port 25. Don't forget to append to the original `firewall_rules` list.
# 5. Print the `ports_by_destination`