# Exercise 5: Firewall Rule Configuration - Solution

firewall_rules = [
    {"source": "192.168.1.0/24", "destination": "10.0.0.1", "port": 80, "action": "allow"},
    {"source": "10.0.0.0/16", "destination": "192.168.1.100", "port": 22, "action": "deny"},
    {"source": "ANY", "destination": "10.0.0.2", "port": 443, "action": "allow"},
    {"source": "192.168.1.50", "destination": "10.0.0.3", "port": 80, "action": "allow"},
]

# 1. Allowed rules.
allowed_rules = []
for rule in firewall_rules:
    if rule["action"] == "allow":
        allowed_rules.append(rule)
print("Allowed Rules:", allowed_rules)

# 2. Ports by destination.
ports_by_destination = {}
for rule in firewall_rules:
    destination = rule["destination"]
    port = rule["port"]
    if destination not in ports_by_destination:
        ports_by_destination[destination] = []
    if port not in ports_by_destination[destination]: # Prevent duplicate entries
        ports_by_destination[destination].append(port)

# 3. Check rule function.
def check_rule(source, destination, port, rules):
    for rule in rules:
        if (rule["source"] == source or rule["source"] == "ANY") and \
           (rule["destination"] == destination or rule["destination"] == "ANY") and \
           rule["port"] == port:
            return rule["action"]
    return "unknown"

# Test cases.
print(check_rule("192.168.1.50", "10.0.0.1", 80, firewall_rules))  # Output: allow
print(check_rule("10.0.0.5", "192.168.1.100", 22, firewall_rules)) # Output: deny
print(check_rule("10.0.0.5", "192.168.1.100", 80, firewall_rules)) # Output: unknown

# 4. Add new rule.
new_rule = {"source": "172.16.0.0/12", "destination": "ANY", "port": 25, "action": "deny"}
firewall_rules.append(new_rule)

# 5. Print
print(ports_by_destination)