# Exercise 6: User Permission Management

# You are building a simple user management system.  User information is stored in a dictionary.

users = {
    "admin": {"permissions": ["read", "write", "execute", "delete"], "active": True},
    "user1": {"permissions": ["read", "write"], "active": True},
    "guest": {"permissions": ["read"], "active": False},
    "testuser": {"permissions": [], "active": True},
}

# 1. Create a function `get_active_users(user_data)` that takes the user dictionary as input and returns a list of usernames who are active.
# 2. Create a function `check_permission(username, permission, user_data)` that checks if a given user has a specific permission.  Return True if they have the permission and are active, False otherwise.
# 3. Create a function `add_user(username, permissions, active, user_data)` that adds a new user to the `user_data` dictionary.  Handle the case where the username already exists (print an error message and don't modify the dictionary).
# 4. Use the `add_user` function to add a user named "poweruser" with permissions "read", "write", and "execute", and set their status to active.
# 5. Test the functions:
#    - Get and print the list of active users.
#    - Check if "user1" has "execute" permission (should be False).
#    - Check if "admin" has "delete" permission (should be True).
#    - Check if "guest" has "read" permission (should be False - because they are inactive)
# 6. Print the `users` dictionary