# Exercise 6: User Permission Management - Solution

users = {
    "admin": {"permissions": ["read", "write", "execute", "delete"], "active": True},
    "user1": {"permissions": ["read", "write"], "active": True},
    "guest": {"permissions": ["read"], "active": False},
    "testuser": {"permissions": [], "active": True},
}

# 1. Get active users.
def get_active_users(user_data):
    active_users = []
    for username, data in user_data.items():
        if data["active"]:
            active_users.append(username)
    return active_users

# 2. Check permission.
def check_permission(username, permission, user_data):
    if username in user_data and user_data[username]["active"]:
        return permission in user_data[username]["permissions"]
    return False

# 3. Add user.
def add_user(username, permissions, active, user_data):
    if username in user_data:
        print(f"Error: User '{username}' already exists.")
    else:
        user_data[username] = {"permissions": permissions, "active": active}

# 4. Add "poweruser".
add_user("poweruser", ["read", "write", "execute"], True, users)

# 5. Test functions.
active_users = get_active_users(users)
print("Active Users:", active_users)
print(f"user1 has execute permission: {check_permission('user1', 'execute', users)}")  # Output: False
print(f"admin has delete permission: {check_permission('admin', 'delete', users)}")  # Output: True
print(f"guest has read permission: {check_permission('guest', 'read', users)}")  # Output: False

# 6. Print user data
print(users)