# Exercise 8: Vulnerability Scanner Results - Solution

scan_results = [
    {"host": "192.168.1.1", "vulnerabilities": ["CVE-2021-1234", "CVE-2020-5678"]},
    {"host": "10.0.0.2", "vulnerabilities": ["CVE-2022-9999"]},
    {"host": "192.168.1.3", "vulnerabilities": ["CVE-2021-1234"]},
    {"host": "10.0.0.5", "vulnerabilities": []},
]

# 1. Vulnerabilities by host.
vulnerabilities_by_host = {}
for result in scan_results:
    vulnerabilities_by_host[result["host"]] = result["vulnerabilities"]
print("vulnerabilities_by_host", vulnerabilities_by_host)

# 2. Vulnerable hosts.
vulnerable_hosts = []
for result in scan_results:
    if result["vulnerabilities"]:  # Check if the list is not empty
        vulnerable_hosts.append(result["host"])
print("Vulnerable Hosts", vulnerable_hosts)

# 3. CVE counts.
cve_counts = {}
for result in scan_results:
    for cve in result["vulnerabilities"]:
        cve_counts[cve] = cve_counts.get(cve, 0) + 1
print("cve_counts", cve_counts)

# 4. Most common CVE.
most_common_cve = ""
max_count = 0
for cve, count in cve_counts.items():
    if count > max_count:
        most_common_cve = cve
        max_count = count
print("Most Common CVE:", most_common_cve, "Count:", max_count)

# 5. Find by CVE Function
def find_hosts_by_cve(cve, results):
    hosts = []
    for result in results:
        if cve in result["vulnerabilities"]:
            hosts.append(result["host"])
    return hosts

# 6.  Test
hosts_with_cve = find_hosts_by_cve('CVE-2021-1234', scan_results)
print(hosts_with_cve)