# Super Challenge 2: Network Packet Analyzer

# You are developing a simplified network packet analyzer.  You'll receive packet data as strings,
# and you need to parse and analyze this data.

# 1. Packet Format:  Each packet is a string with the following comma-separated fields:
#    "Source IP,Destination IP,Protocol,Length,Data"
#    - Data is a hexadecimal string representing the packet payload.

# 2.  Create a function `parse_packet(packet_string)` that takes a packet string and returns a dictionary
#    with the following keys:
#    - "source_ip" (string)
#    - "destination_ip" (string)
#    - "protocol" (string)
#    - "length" (integer)
#    - "data" (string, the hexadecimal data)
#    - "data_decoded" (string, the ASCII representation of the data, or "<binary data>" if not printable)

# 3. Create a function `analyze_packets(packets)` that takes a list of parsed packet dictionaries and performs
#   the following analysis:
#    - Calculates the average packet length.
#    - Counts the number of packets for each protocol.
#    - Identifies the most frequent destination IP.
#   - Returns a dictionary containing these statistics:  {"average_length": ..., "protocol_counts": {...}, "most_frequent_destination": ...}

# 4.  Create a function `filter_packets(packets, protocol=None, source_ip=None, destination_ip=None)` that
#   filters the packets based on the given criteria. All filter parameters are optional.

# 5. Test your analyzer with the sample packet data.  Show the results of parsing, analysis, and filtering.
#    - Filter by protocol "TCP"
#   - Filter by source IP "10.0.0.1"


packet_data = [
    "192.168.1.1,10.0.0.2,TCP,64,48656c6c6f2c20776f726c6421",  # "Hello, world!" in hex
    "10.0.0.1,192.168.1.2,UDP,128,000102030405060708090a0b0c0d0e0f",
    "192.168.1.1,10.0.0.3,TCP,80,54686973206973206120746573742e",  # "This is a test." in hex
    "10.0.0.4,192.168.1.4,ICMP,56,89abcdef01234567",
    "192.168.1.5,10.0.0.2,TCP,72,416e6f74686572206d6573736167652e",  # "Another message." in hex
]


def parse_packet(packet_string):
    # Implement packet parsing logic here
    pass  # Replace with your code

def analyze_packets(packets):
    # Implement packet analysis logic here
    pass  # Replace with your code

def filter_packets(packets, protocol=None, source_ip=None, destination_ip=None):
    # Implement packet filtering logic
    pass

# --- Main Program Execution ---

# 1. Parse all packets
parsed_packets = []
for packet in packet_data:
  parsed_packets.append(parse_packet(packet))

# 2. Show parsed packets
print("--- Parsed Packets ---")
for packet in parsed_packets:
    print(packet)
# 3. Analyze
analysis_results = analyze_packets(parsed_packets)
print("\n--- Analysis Results ---")
print(analysis_results)

# 4. Filter and show results
print("\n--- Filtered Packets (TCP) ---")
tcp_packets = filter_packets(parsed_packets, protocol="TCP")
for packet in tcp_packets:
    print(packet)

print("\n--- Filtered Packets (Source IP: 10.0.0.1) ---")
source_ip_packets = filter_packets(parsed_packets, source_ip="10.0.0.1")
for packet in source_ip_packets:
    print(packet)