def exercise_1() -> None:
    """Prompts for an integer, multiplies by 100 if valid.
    
    Handles invalid input and keyboard interrupts gracefully.
    """
    try:
        num_str = input("Enter an integer: ")
        try:
            num = int(num_str)
            result = num * 100
            print(f"Result: {result}")
        except ValueError:
            print("Error: Input must be a valid integer")
    except KeyboardInterrupt:
        print("\nOperation cancelled by user")
        return

def exercise_2():
    num_str = input("Enter a floating-point number: ")
    num = float(num_str)
    result = num * 100
    print(result)

def exercise_3():
    num1_str = input("Enter the first number: ")
    num2_str = input("Enter the second number: ")
    num1 = float(num1_str)  # Use float to handle potential decimals
    num2 = float(num2_str)

    if num1 < num2:
        print("Low/High")
    elif num2 < num1:
        print("High/Low")
    else:
        print("Equal")

def exercise_4():
    wage_str = input("Enter hourly wage: ")
    hours_str = input("Enter number of hours worked: ")

    if wage_str.startswith("$"):
        wage = float(wage_str[1:])  # Remove the dollar sign
    else:
        wage = float(wage_str)

    hours = float(hours_str)

    if hours > 40:
        overtime_hours = hours - 40
        regular_pay = 40 * wage
        overtime_pay = overtime_hours * wage * 1.5
        total_pay = regular_pay + overtime_pay
    else:
        total_pay = hours * wage

    print(f"Wages to be paid: {total_pay}")

def exercise_5():
    age = int(input("Enter person's age: "))
    citizenship_years = int(input("Enter years of citizenship: "))

    print("Eligibility:")
    if age >= 30 and citizenship_years >= 9:
        print("US Senator: Eligible")
    else:
        print("US Senator: Not Eligible")

    if age >= 25 and citizenship_years >= 7:
        print("US Representative: Eligible")
    else:
        print("US Representative: Not Eligible")

    if age >= 35 and citizenship_years == age:  # Born a US citizen
        print("US President: Eligible")
    else:
        print("US President: Not Eligible")

def exercise_6():
    year = int(input("Enter a year: "))

    if (year % 4 == 0 and year % 100 != 0) or (year % 400 == 0):
        print(f"{year} is a leap year.")
    else:
        print(f"{year} is not a leap year.")