# -- ex_1 -- #
# Finish the function that takes two arguments: a list and an item to add to the list.
# The function should add the item to the list and return True if successful.
#
# Then modify the function to handle immutable collections like tuples.
# If the collection is immutable, the function should create and return a new
# collection with the added item.
# If the collection is mutable, it should modify the original and return True.
#
# Use type checking to determine if the collection is mutable or immutable.
# Hint: isinstance() can check if an object is a specific type.

# Example:
# ex_1([1, 2, 3], 4)  # Returns True
# ex_1((1, 2, 3), 4)  # Returns (1, 2, 3, 4)


def ex_1(collection, item):

    # Check all mutable types
    if isinstance(collection, list):
        collection.append(item)
        return True
    # ADD MORE MUTABLE TYPES HERE

    # Check all immutable types
    # ADD MORE IMMUTABLE TYPES HERE


# -- ex_3 -- #
# Create a function that demonstrates the difference between shallow and deep copies.
#
# The function should:
# 1. Create a nested list: original = [[1, 2, 3], [4, 5, 6], [7, 8, 9]]
# 2. Create a shallow copy of the list using the slice operator [:]
# 3. Create a deep copy using the 'copy' module
# 4. Modify original[0][0] = 'X'
# 5. Print all three lists to show how the change affects each
# 6. Return a boolean indicating whether the deep copy remained unchanged (True)
#    or was affected by the modification (False)

def ex_3():
    pass


# -- ex_4 -- #
# Write a function that demonstrates the utility of tuples.
#
# The function should:
# 1. Create a dictionary where the keys are (x, y) coordinate tuples
#    and the values are what would be found at those "locations"
# 2. Implement a function get_neighbors(coord) that takes a coordinate tuple
#    and returns a list of values from adjacent coordinates
#    (up, down, left, right)
# 3. Use tuple unpacking to process coordinates
# 4. Demonstrate a function that returns multiple values as a tuple
#    and show how to unpack these values
#
# Example:
# - If (0,0) contains "treasure" and (0,1) contains "monster",
#   get_neighbors((0,0)) would include "monster" in the result

def ex_4():
    # Create a dictionary with coordinate tuples as keys
    grid = {
        (0, 0): "treasure",
        (0, 1): "monster",
        (1, 0): "key",
        (1, 1): "potion",
        (2, 2): "exit"
    }
    def get_neighbors(coord):
        pass

    # Test the function
    print(get_neighbors((0, 0)))

# -- ex_5 -- #
# Create a function that processes student attendance data using sets.
#
# The function should:
# 1. Find students who attended all days (intersection of all sets)
# 2. Find students who attended at least one day (union of all sets)
# 3. Find students who attended Monday but didn't show up on Friday
# 4. Find students who only attended on Wednesday
# 5. Create and print a dictionary where keys are student names and
#    values are the count of days they attended

def ex_5():
  # Define sets for students who attended each day
    monday = {"Alice", "Bob", "Charlie", "David", "Eve"}
    tuesday = {"Alice", "Bob", "David", "Frank", "Grace"}
    wednesday = {"Alice", "Charlie", "Eve", "Frank", "Grace"}
    thursday = {"Bob", "Charlie", "David", "Eve", "Frank"}
    friday = {"Alice", "Bob", "David", "Grace", "Heidi"}


# -- ex_6 -- #
# Create a function that uses namedtuples from the collections module
# to represent and process employee data.
#
# The function should:
# 1. Define an Employee namedtuple with fields: id, name, dept, salary
# 2. Create a list of at least 5 employees with varied data (already done)
# 3. Calculate and print the average salary by department
# 4. Find the highest paid employee in each department
# 5. Create a new list with all employees receiving a 10% raise,
#    using the _replace() method

def ex_6():
    Employee = # FIXME

    # Create a list of employees
    employees = [
        Employee(101, "Alice Johnson", "Engineering", 85000),
        Employee(102, "Bob Smith", "Marketing", 72000),
        Employee(103, "Charlie Davis", "Engineering", 92000),
        Employee(104, "Diana Miller", "HR", 65000),
        Employee(105, "Edward Wilson", "Marketing", 68000),
        Employee(106, "Fiona Taylor", "Engineering", 79000),
        Employee(107, "George Brown", "HR", 61000)
    ]



# -- BONUS ex_7 -- #
# Write a function that demonstrates working with multiple collection types.
#
# The function should simulate a simple inventory management system:
# 1. Use a dictionary to store items where:
#    - Keys are tuples of (item_id, item_name)
#    - Values are dictionaries with keys 'quantity', 'price', 'categories'
#    - 'categories' should be a set of categories the item belongs to
# 2. Implement the following operations:
#    - add_item(inventory, item_id, item_name, quantity, price, categories)
#    - update_quantity(inventory, item_id, item_name, change)
#    - get_items_by_category(inventory, category)
#    - get_total_value(inventory) → sum of price * quantity for all items
# 3. Ensure appropriate error handling for item not found cases

def ex_7():
    pass


# -- BONUS ex_8 -- #
# Create a function that processes text data from a file
# and uses advanced data structures for analysis.
#
# The function should:
# 1. Read a text file containing lines of text (create a sample file)
# 2. Count word frequency (use a dictionary)
# 3. Find unique words (use a set)
# 4. Store specific information about each unique word in a namedtuple
#    (e.g., Word(text, count, first_line, last_line))
# 5. Create a tuple of the top 5 most common words
# 6. Use shallow and deep copying where appropriate
# 7. Write the results to a new file

def ex_8():
    pass


if __name__ == "__main__":
    pass
    # Uncomment the challenge you want to run
    # ex_1([1, 2, 3], 4)
    # ex_2()
    # ex_3()
    # ex_4()
    # ex_5()
    # ex_6()
    # ex_7()
    # ex_8()