# pylint: disable=W0105

# -- ex_1 -- #
"""
Write a function called 'calculate_average' that takes a list of numbers
and returns the average (mean) of those numbers.

If the list is empty, return 0.

Example:
calculate_average([1, 2, 3, 4, 5]) should return 3.0
calculate_average([]) should return 0
"""
def calculate_average():
    pass


# -- ex_2 -- #
"""
Create a function called 'greet_user' that takes a name and a greeting.
The greeting should have a default value of "Hello".
The function should return a string that combines the greeting and the name.

Example:
greet_user("Alice") should return "Hello, Alice!"
greet_user("Bob", "Good morning") should return "Good morning, Bob!"
"""

def greet_user():
    pass


# -- ex_3 -- #
"""
Write a function called 'get_dimensions' that calculates the area and perimeter
of a rectangle and returns both values.

The function should take two parameters: length and width.

Example:
area, perimeter = get_dimensions(5, 3)
print(area)      # Should print 15
print(perimeter) # Should print 16
"""

def get_dimensions():
    pass


# -- ex_4 -- #
"""
Create a function called 'print_arguments' that accepts any number of
positional and keyword arguments and prints them out in a formatted way.

The function should print all positional arguments with their index,
followed by all keyword arguments with their keys.

Example:
print_arguments(1, 2, 3, name="Alice", age=30)
Output:
Positional argument 0: 1
Positional argument 1: 2
Positional argument 2: 3
Keyword argument name: Alice
Keyword argument age: 30
"""

def print_arguments(*args, **kwargs):
    pass


# -- ex_5 -- #
"""
Write a function called 'modify_global' that demonstrates variable scope.

The function should:
1. Define a local variable called 'x' with value 10
2. Define a nested function called 'inner' that:
    a. Uses nonlocal to modify the outer function's 'x' to 20
    b. Prints the value of 'x'
3. Call the 'inner' function
4. Print the value of 'x' after calling 'inner'
5. Return the value of 'x'

Example:
result = modify_global()
print(result)  # Should print 20
"""

def modify_global():
    pass


# -- ex_6 -- #
"""
Create a function called 'transform_list' that uses lambda functions with
map, filter, and sorted to process a list of numbers.

The function should:
1. Take a list of numbers as input
2. Filter out all odd numbers
3. Square each remaining number
4. Sort the results in descending order
5. Return the transformed list

Example:
transform_list([1, 2, 3, 4, 5, 6]) should return [36, 16, 4]
"""

def transform_list():
    pass


# -- ex_7 -- #
"""
Write a function called 'calculate_discounted_price' with proper docstrings
following Google style documentation.

The function should:
1. Take a price and discount percentage as input
2. Validate that both are positive numbers
3. Calculate the discounted price (original price - (original price * discount / 100))
4. Return the discounted price rounded to 2 decimal places

Your docstring should include:
- A description of what the function does
- Args section describing each parameter
- Returns section describing the return value
- Raises section describing any exceptions raised

Example:
calculate_discounted_price(100, 20) should return 80.0
"""

def calculate_discounted_price():
    """Add your docstring here.
    """
    pass


# -- ex_8 -- #
"""
Create a function called 'process_data' with proper type hints.

The function should:
1. Take a list of strings and an optional boolean flag 'uppercase' (default to False)
2. If uppercase is True, convert all strings to uppercase
3. Remove any empty strings
4. Return a dictionary where keys are the strings and values are their lengths

Add appropriate type hints for parameters and return value.

Example:
process_data(["hello", "", "world"], uppercase=True)
should return {"HELLO": 5, "WORLD": 5}
"""

def process_data(strings, uppercase=False):
    pass


# -- ex_9 -- #
"""
Write a higher-order function called 'apply_operation' that:
1. Takes a function and a list of numbers as input
2. Applies the function to each number in the list
3. Returns a new list with the results

Then create three different functions that can be passed to apply_operation:
- square: returns the square of a number
- cube: returns the cube of a number
- double: returns twice the value of a number

Example:
apply_operation(square, [1, 2, 3]) should return [1, 4, 9]
apply_operation(cube, [1, 2, 3]) should return [1, 8, 27]
apply_operation(double, [1, 2, 3]) should return [2, 4, 6]
"""

def apply_operation():
    pass

def square(x):
    pass

def cube(x):
    pass

def double(x):
    pass


# -- BONUS ex_10 -- #
"""
Create a closure function called 'counter_factory' that:
1. Creates and returns a function that increments a counter
2. The returned function should increment the counter by a specified step size
3. The returned function should also have an option to reset the counter to zero

Example:
counter1 = counter_factory(step=1)
print(counter1())  # Should print 1
print(counter1())  # Should print 2

counter2 = counter_factory(step=5)
print(counter2())  # Should print 5
print(counter2())  # Should print 10

print(counter1(reset=True))  # Should print 0
print(counter1())  # Should print 1
"""

def counter_factory(step=1):
    pass


# -- BONUS ex_11 -- #
"""
Create a function that validates input parameters based on type and value constraints.

The function should:
1. Take parameters: name (string), age (integer), email (string), and scores (list of numbers)
2. Validate that:
    - name is a non-empty string
    - age is an integer between 0 and 120
    - email contains an '@' symbol
    - scores is a non-empty list and all elements are numbers between 0 and 100
3. If any validation fails, raise an appropriate exception with a descriptive message
4. If all validations pass, return a dictionary with the validated data

Example:
validate_person_data("Alice", 25, "alice@example.com", [85, 90, 95])
Should return {'name': 'Alice', 'age': 25, 'email': 'alice@example.com', 'scores': [85, 90, 95]}
"""

def validate_person_data(name, age, email, scores):
    pass


# -- BONUS ex_12 -- #
"""
Create a function called 'memoize' that implements a memoization decorator.

The decorator should:
1. Cache the results of a function based on its arguments
2. Return the cached result when the function is called again with the same arguments
3. Store the cache as a dictionary in the closure

Then create a function called 'fibonacci' that calculates the nth Fibonacci number recursively.
Apply the memoize decorator to it to improve its performance.

Example:
fibonacci(10) should return 55 quickly
fibonacci(30) would be very slow without memoization, but should be fast with memoization
"""

def memoize():
    pass

@memoize
def fibonacci(n):
    pass


if __name__ == "__main__":
    pass
    # Uncomment to test your functions
    # print(calculate_average([1, 2, 3, 4, 5]))
    # print(greet_user("Alice"))
    # print(greet_user("Bob", "Good morning"))

    # area, perimeter = get_dimensions(5, 3)
    # print(f"Area: {area}, Perimeter: {perimeter}")

    # print_arguments(1, 2, 3, name="Alice", age=30)

    # result = modify_global()
    # print(f"Result from modify_global: {result}")

    # print(transform_list([1, 2, 3, 4, 5, 6]))

    # print(calculate_discounted_price(100, 20))

    # print(process_data(["hello", "", "world"], uppercase=True))

    # print(apply_operation(square, [1, 2, 3]))
    # print(apply_operation(cube, [1, 2, 3]))
    # print(apply_operation(double, [1, 2, 3]))

    # counter1 = counter_factory(step=1)
    # print(counter1())
    # print(counter1())
    # counter2 = counter_factory(step=5)
    # print(counter2())
    # print(counter2())
    # print(counter1(reset=True))
    # print(counter1())

    # try:
    #     print(validate_person_data("Alice", 25, "alice@example.com", [85, 90, 95]))
    #     print(validate_person_data("", 25, "alice@example.com", [85, 90, 95]))  # Should raise an exception
    # except Exception as e:
    #     print(f"Validation error: {e}")

    # print(fibonacci(10))
    # print(fibonacci(30))