# Python Programming Fundamentals JQR

## 7.1 Foundational Python Mechanics
- The return statement
- Data types
- Functions
- Parameters
- Scope
- Return values (return type and reference)
- Import files
- Dictionaries
- List
- Tuple
- Singleton
- The term mutable
- The term immutable


## 7.2 Python Data Types and Object-Oriented Constructs
- Integer (int)
- Float (float)
- String (str)
- List (list)
- Multi-dimensional list
- Dictionary (dict)
- Tuple (tuple)
- Singleton


## 7.3 Basic Arithmetic Operations (PEMDAS)
- Addition
- Subtraction
- Multiplication
- Division
- Modulus


## 7.4 File Management Operations
- Open an existing file
- Read data from a file
- Parse data from a file
- Write data to a file
- Modify data in a file
- Close an open file
- Print file information to the console
- Create a new file
- Append data to an existing file
- Delete a file
- Determine the size of a file
- Determine location within a file
- Insert data into an existing file


## 7.5 Function Implementation
- Functions that return multiple values
- Functions that receive input from a user
- Recursive functions


## 7.6 Data Validation
- Validating received input matches expected input
- Designing and implementing a scheme for exception handling


## 7.7 Conditional Statements and Control Flow
- for loop
- while loop
- with statement
- if statement
- if/else statement
- if/elif/else statement
- try/except/finally


## 7.8 Object-Oriented Programming Fundamentals

### Training Resources & Technical References:

- [Design Patterns](https://github.com/GunterMueller/Books-3/blob/master/Design%20Patterns%20Elements%20of%20Reusable%20Object-Oriented%20Software.pdf)

### Topics:
- Class
- Object
- Difference between an object when discussing a class
- Advantages to object-oriented programming
- Inheritance
- The keyword "super"
- Initialization function of a constructor
- The keyword "self"
- The getter and setter functions
- Attributes of a class



## 7.9 Command Line Arguments
- Demonstrate the ability to parse command line arguments using built-in functionality