# Welcome

![USCC Logo](uscc.png)

## What is a Capability Developer?

Cyber Capability Developer (CCD) is a joint work role for service members that develop Offensive and Defensive capabilities for the military. The work role has three levels of certification: **Basic**, **senior**, and **master**. Each level has its own associated Job Qualification Record (JQR) which details the skills someone needs to maintain to become certified. Once a candidate has demonstrated the directed skill, someone already qualified in the work role will verify the work and confirm the candidate has a competency in the skill. These line items must be verified by someone already qualified in the work role in that level. For example, a basic developer can only verify basic tasks, but a senior can verify both senior and basic tasks. Everyone completes the same basic certification but specialize into a specific discipline at the senior level.

## Basic JQR information

<!-- TODO #58: replace this with a link to the most up to date JQR at any given time or a job that runs the joint JQS pipeline and puts the artifact in "assets" -->

The most current JQR can be found [here](00_Introduction/jqr_basic_ccd.pdf).

## Suggested Study Material

- [oreilly.com](https://www.oreilly.com/member/login/)
    - Use military email for free access to ALL textbooks you'd ever need, including many listed below.
- [digitalu](https://digitalu.af.mil)
    - A military portal to get free access to Udemy for business. Normally paid resources are free here. An excellent source of video lecture material.
- [Beej's Guides](https://beej.us/guide/)
    - Most known for his guide on C networking sockets, these guides contain very understandable tutorials on the C programming language.
- [The C Programming Language 2nd Ed](https://www.oreilly.com/library/view/c-programming-language/9780133086249/)
    - The undisputed "bible" for C, written by the masters Kernighan and Ritchie themselves.
- [The Linux Programming Interface](https://www.oreilly.com/library/view/the-linux-programming/9781593272203/)
    - Written by the author of the man pages project, this book goes over nearly every system call in Linux.
- [man(ual) pages](https://man7.org/linux/man-pages/dir_all_alphabetic.html)
    - Every function/system call and details about how it works.
- [Operating Systems: Three Easy Pieces](https://pages.cs.wisc.edu/~remzi/OSTEP/)
    - A free online operating systems book covering virtualization, concurrency, and persistence.
- [Fluent Python 2nd ed](https://www.oreilly.com/library/view/fluent-python-2nd/9781492056348/)
    - 5 books in one for python that covers data structures, functions as objects, object-oriented idioms, control flow, and metaprogramming.
- [Embedded C Coding Standard (Barr)](https://barrgroup.com/sites/default/files/barr_c_coding_standard_2018.pdf)
    - A popular style guide in the force. Note, this may or may not be what your unit uses, but being able to follow a style guide is an important skill that can be an indicator of how ready one is to join a team.
