# Objectives

* Gain a better understanding of previously covered concepts of the Python programming language
through the completion of practical exercises.

# Exercises

## Exercise 1

```python
"""
With the maze below, write directions to move through the maze,
picking up each coin as you go,
using only the instructions: forward, left, and right.

Write one instruction per line on your paper.
Start at the entry to the maze and move until each coin is
picked up before returning the the entry point.

Moving into a square that has a coin will collect that coin.

Each coin can be collected only once, though its path can be
crossed multiple times.

Directions are from the point of view as if a person were
standing in the maze.

forward - moves one square
left - turns 90 degrees to the left, but does not move a square
right - turns 90 degrees to the right, but does not move a square
"""

```

![Coin Maze!](maze.png)

## Exercise 2

```python
"""
With the name tags shown below, write directions to move each
of the name tags so that they are in alphabetical order.

Use only the directions left and right.
Write one instruction per line on your paper.

Each instruction should include the name tag and the direction,
such as: Andrew right

Each instruction will only move the given name tag one
location to the left or right.

Example:
Trevor left  # moves Trevor between Yvonne and Declan.
"""

```

![Name Tags!](names.png)

## Exercise 3

```python
"""
Use the interactive `help()` function to find additional
information on 4 topics from the list of available `topics`.

Some recommended topics include `str`, `int`, `float`, `bool`,
`print`, and `input`.
"""

```

## Exercise 4

```python
"""
Use the interactive Python shell(REPL) to assign a literal string
for a first name in one variable and another literal string
for the last name.

Print the information in the two variables as a full name.
"""

```

## Exercise 5

```python
"""
Place the code used in the previous two exercises into a
python file, with a name of your choosing.

The file name should be indicative as to what the program does.

Run the program from the command line.
"""

```

## Exercise 6

```python
"""
Edit the file created in the previous exercise such that the last name is printed before the first name, separated by a comma.

Rather than save over the original file, Save this version of the file under a new name and execute (run) it.
"""

```

## Exercise 7

```python
"""
A person receives a dime, 2 nickels, 2 quarters, and 4 pennies
in change from a purchase.

Write a program to calculate how much money was received in
change.
"""

```

## Exercise 8

```python
"""
A video streaming service is being offered for $15 a month
with a 10% discount for buying a years worth in advance.

Write a program that answers the following questions:

What is the yearly price for someone paying per month and
the discounted yearly rate?

How much is saved in a year by purchasing the yearly
membership over the monthly membership?
"""

```

## Exercise 9

```python
"""
What is the difference in height (in inches) of one person
who stands 7'2" and another that stands 5'8"?
"""

```

## Exercise 10

```python
"""
Create four literal strings, with each one holding the Unicode
characters for the 13 playing cards in a suit: Ace, Two, ...
Queen, King.

Print the four strings to output a deck of cards.
"""

```

## Exercise 11

```python
"""
Print out the number 129 in binary, octal, and hexadecimal.

Then define variables to hold the number 129 supplied as a
binary literal, octal literal, and a hexadecimal literal value.
"""

```
## Exercise 12

```python
"""
Given the following statement: `letter = "A"`.

Use the `ord()` and `chr()` functions to print out the
letter `B`.
"""

```
## Exercise 13

```python
"""
Store the literal string of Hello in as many ways as you
can think of.

Each representation should be stored in its own variable.
"""

```

## Exercise 14

```python
# Determine how many different string objects are stored in the
# variables below.

farewell_a = "Goodbye"
farewell_b = "Goodbye"
farewell_c = 'Goodbye'
farewell_d = "Good" + "bye"
farewell_e = "good" + 'bye'
farewell_f = "goodbye"
farewell_g = 'adios,' + 'dag,' + 'さようなら,' + \
             'Auf Wiedersehen,' + 'later'
farewell_h = str(farewell_g)
```

## Exercise 15

```python
"""
Print the numbers 1 through 10, inclusive, as comma separated
values all on the same line.
"""

```


## Exercise 16

```python
"""
Using a single `print` statement:

Print the numbers 1 through 10, inclusive, with each number
on its own line in the output.
"""

```

## Exercise 17

```python
"""
Write an application that prompts the user to enter a name
three times and stores each name in its own variable.

After collecting the names, print all of the names on a
single line.
"""

```

## Exercise 18

```python
"""
Rewrite the previous application so that it also prints, on a
separate line, the total number of characters in all of the
names supplied.
"""

```

## Exercise 19

```python
"""
Rewrite the previous application once again so that the output:

Prints each name and the number of characters in the name.
The name should be first and the length second.
The name and length should be right justified with a minimum
width of 15.
"""

```

## Exercise 20

```python
"""
A student wishes to be able to determine their grade average
after taking 5 tests.

Write an application that allows the user to input all 5 test
scores and print out the average.
"""

```