# Abstract Base Classes

## Learning Objectives
Gain clarity around the use of the term protocol in Python
Learn how type hints facilitate static type checking
Learn how protocols allow static duck typing
Create custom protocols with the Protocol class
Understand the differences between protocols and abstract base classes

## Protocols vs Abstract Base Classes
Before there were protocols, these tools could only check for nominal subtyping based on inheritance. There was no way to check for structural subtyping, which relies on the internal structure of classes. This limitation affected Python’s duck typing system, which allows you to use objects without considering their nominal types. Protocols overcome this limitation, making static duck typing possible.




if two object support a protocol (Python defined or user defined), then they are considered to be duck-typed and compatible.







ABCs are suitable when you have control over the class hierarchy and want to define a consistent interface across subclasses. Meanwhile, protocols are useful in scenarios where modifying class hierarchies is impractical or when there’s no clear inheritance relationship between classes.




ABCs use the inheritance mechanism to ensure that subclasses implement the required methods.

Protocols do not use inheritance. Instead, they use the concept of delegation to check if an object conforms to a protocol.














External Resources:
- [Real Python - Duck Typing in Python](https://realpython.com/duck-typing-python/)
- [Real Python - Python Protocol](https://realpython.com/python-protocol/)
- [Python ABCs](https://docs.python.org/3/library/collections.abc.html#collections-abstract-base-classes)




Credits:

- [ArjanCodes YT](https://youtu.be/xvb5hGLoK0A?si=miPVoF7m2g63ZyZl)
- [ArjanCodes GitHub](https://github.com/ArjanCodes/2021-protocol-vs-abc/tree/main/protocol/iot)
