# names_module.py

_private_var = "I'm a private module variable"
__mangled_var = "I'm a mangled module variable"
public_var = "I'm a public module variable"

def _private_function():
    return "I'm a private module function"

def public_function():
    return "I'm a public module function"

class MyClass:
    def __init__(self):
        self._weak_private = 1  # Weakly private
        self.__strong_private = 2  # Strongly private (name mangling)
        self.public = 3  # Public

    def _private_method(self):
        return "I'm a private method"

    def public_method(self):
        return "I'm a public method"

    def get_strong_private(self):
        return self.__strong_private

class ChildClass(MyClass):
    def __init__(self):
        super().__init__()
        self.__strong_private = 4  # This creates a new attribute, doesn't override parent's
