# No dataclass example
class Product:
    def __init__(self, name: str, price: float, quantity: int = 0):
        self.name = name
        self.price = price
        self.quantity = quantity

    def __repr__(self):
        return f"Product(name={self.name}, price={self.price}, quantity={self.quantity})"

    def __eq__(self, other):
        if not isinstance(other, Product):
            return False
        return (self.name == other.name and
                self.price == other.price and
                self.quantity == other.quantity)

    def total_price(self) -> float:
        return self.price * self.quantity

p1 = Product("Laptop1", 1000, 1)
p2 = Product("Laptop2", 750, 2)

print(f"p1: {p1.total_price()}")
print(f"p2: {p2.total_price()}")
print(f"Product:\n{dir(Product)}")

try:
    print(f"is p1 == p2: {p1 == p2}")  # False
except TypeError as e:
    print(f"Error comparing equality: {e}")

try:
    print(f"is p1 > p2: {p1 > p2}")  # True
except TypeError as e:
    print(f"Error comparing greater than: {e}")

try:
    print(f"is p1 < p2: {p1 < p2}")  # False
except TypeError as e:
    print(f"Error comparing less than: {e}")