import functools

# ===========NO RETURN===================
def do_twice(func):
    def wrapper_do_twice(*args, **kwargs):
        func(*args, **kwargs)
        func(*args, **kwargs)

    return wrapper_do_twice

@do_twice
def hello3(name):
    print("I'm saying hello")
    return f"Hello {name}"
# ==============================

# ============RETURN==================
def do_twice_new(func):
    @functools.wraps(func)
    def wrapper_do_twice(*args, **kwargs):
        func(*args, **kwargs)
        return func(*args, **kwargs)

    return wrapper_do_twice

@do_twice_new
def hello3_new(name):
    print("I'm saying hello")
    return f"Hello {name}"
# ==============================

print(hello3("Jimmy"))
print(f"hello3.__name__: {hello3.__name__}")
print(hello3_new("Jimmy"))
print(f"hello3_new.__name__: {hello3_new.__name__}")
