# property decorator


class Person:
    def __init__(self, name, age):
        self._name = name
        self.age = age

    @property
    def age(self):
        return self._age

    @age.setter
    def age(self, value):
        try:
            if value < 0:
                raise ValueError("Age cannot be negative")
        except ValueError as e:
            print(e)
        self._age = value


person = Person("John", -30)
print(type(person.age))
person.age = 40
print(person.age)
try:
    person.age = -10
except ValueError as e:
    print(e)
print(person.age)
