import functools
import time


def timer(func):
    """Print the runtime of the decorated function"""

    def wrapper_timer(*args, **kwargs):
        start_time = time.perf_counter()
        value = func(*args, **kwargs)
        end_time = time.perf_counter()
        run_time = end_time - start_time
        print(f"Finished {func.__name__}() in {run_time:.4f} secs")
        return value

    return wrapper_timer


@timer
def o_of_n_squared(n):
    sum = 0
    for i in range(n):
        for j in range(n):
            sum += i * j
    return sum


print(o_of_n_squared(500))
print(o_of_n_squared(1000))
print(o_of_n_squared(5000))
