from abc import ABC, abstractmethod
class Switchable(ABC):
    @abstractmethod
    def operate(self):
        pass

class LightBulb(Switchable):
    def __init__(self):
        self.is_on = False

    def operate(self):
        self.is_on = not self.is_on
        print(f"LightBulb is {'on' if self.is_on else 'off'}")

class Fan(Switchable):
    def __init__(self):
        self.is_on = False

    def operate(self):
        self.is_on = not self.is_on
        print(f"Fan is {'on' if self.is_on else 'off'}")
class Switch:
    def operate(self, device: Switchable):
        device.operate()

# Usage
bulb = LightBulb()
fan = Fan()
switch = Switch()
for i in range(5):
    switch.operate(bulb)
    switch.operate(fan)