class FibonacciIterable:
    def __init__(self, limit):
        self.limit = limit

    def __iter__(self):
        return FibonacciIterator(self.limit)

class FibonacciIterator:
    def __init__(self, limit):
        self.limit = limit
        self.a, self.b = 0, 1

    def __iter__(self):
        return self

    def __next__(self):
        if self.a > self.limit:
            raise StopIteration
        result = self.a
        self.a, self.b = self.b, self.a + self.b
        return result

# Usage
fib1 = FibonacciIterable(100)

print("\nUsing FibonacciIterable:")
for x in range(2):
    print(f"\nPrinting FibonacciIterable sequence {x+1}:")
    for num in fib1:
        print(num, end=' ')
print()

print("\nUsing FibonacciIterator:")
fib2 = FibonacciIterator(100)

for x in range(2):
    print(f"\nPrinting FibonacciIterator sequence {x+1}:")
    for num in fib2:
        print(num, end=' ')
print()
