class SimpleIterable:
    def __init__(self, a1, a2, a3, a4):
        self.a1 = a1
        self.a2 = a2
        self.a3 = a3
        self.a4 = a4

    def __iter__(self):
        yield self.a1
        yield self.a2
        yield self.a3
        yield self.a4

# Usage demonstration
simple = SimpleIterable(10, 20, 30, 40)

for x in simple:
    print(f"x: {x}")

# The __iter__ method returns a generator object (which is an iterator)
iterator = iter(simple)

print(f"type(iterator): {type(iterator)}")

# Each call to next() resumes the generator function
print(f"next(iterator): {next(iterator)}")
print(f"next(iterator): {next(iterator)}")
print(f"next(iterator): {next(iterator)}")
print(f"next(iterator): {next(iterator)}")
