import smiley
import unicodedata

def main():
    mysterious_emoji = "😊󠅘󠅕󠅜󠅜󠅟"  # Pre-encoded "hello"

    print("Let's look at this emoji:")
    print(mysterious_emoji)
    print("Looks normal, right?\n")
























    # --- The "Trick" ---
    decoded_bytes = smiley.decode(mysterious_emoji)
    decoded_message = decoded_bytes.decode('utf-8')
    print("Now let's try decoding it as UTF-8... 🤔")
    print(f"Decoded message: {decoded_message}\n")

    # --- Reveal Options (Choose One or More) ---

    # Option 3:  Use unicodedata.name() (Descriptive)
    print("--- Option 3: Use unicodedata.name() ---")
    print("Here's each character's Unicode name:")
    for char in mysterious_emoji:
        try:
            name = unicodedata.name(char)
        except ValueError:
            name = "NO NAME (likely a control character)"
        print(f"  '{char}' : {name}")
    print(" (Look for 'VARIATION SELECTOR' in the names.)\n")

    #Option 4: show the byte values.
    print("--- Option 4: Show the byte values ---")
    print("Here's each characters' byte value, in hex:")
    for char in mysterious_emoji:
        byte_val = smiley.variation_selector_to_byte(char)
        if byte_val is not None:
            print(f" '{char}' : 0x{byte_val:02x}")
        else:
            print(f" '{char}' : Not a variation selector")


if __name__ == "__main__":
    main()